/* emps.h */

#define MAX 5             /* maximum number of employees */

struct employees {
   char name [45];
   long id;
   int  dept;
   int  age;
};

/* display menu and get user menu selection */
char get_selection (void); 

/* perform the user's menu selection */
void process_selection (
   const char selection,           /* selected menu option */
   struct employees *employee,     /* employee list */
   int *idx,                       /* current count of employees */
   int *done);                     /* does user want to quit? */

/* allow entry of new employee */
void add_employee (
   struct employees *employee,     /* employee list */
   int *idx);                      /* current of employees */

/* display the employees entered */
void display_all (
   const struct employees *employee,    /* list of employees */
   int idx);                            /* current count of employees */

/* display a selected employee, or enter if not found */
void display_an_employee (
   struct employees *employee,     /* list of employees */
   int *idx);                      /* current count of employees */

/* remove a selected employee from the array */
void remove_emp (
   struct employees *employee,     /* list of employees */
   int *idx);                      /* current count of employees */

/* have over-extended the array bounds */
void print_sorry (void);

/* display user-defined prompt to continue */
void go_on (const char *);
