/* process_selection.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "emps.h"

void process_selection (
   const char selection, struct employees *employee, int *idx, int *done)
{
   /* declare a function pointer, to be passed into the sort function
      allowing one sort routine using different sort criteria. */

   int (*compare)(const struct employees *left, 
		  const struct employees *right);
   
   switch (selection)
   {
      case 'e':                 /* enter a new emp's info */
      case 'E':
         if (*idx < MAX)
            add_employee (&employee[*idx], idx);
         else
	    print_sorry ();
         break;
      case 'a':                 /* display all emps info */
      case 'A':
         display_all (employee, *idx);
	 break;
      case 'd':                 /* display an emps info */
      case 'D':
         display_an_employee (employee, idx);
         break;
      case 'r':			/* remove an employee */
      case 'R':
         if (*idx > 0)
	    remove_emp (employee, idx);
         else
            go_on("There are no employees in the list." 
	          "  Press ENTER to continue >");
	 break;
      case 's':			/* sort employees by age */
      case 'S':
	 compare = age_compare;   
	 sort (*idx, employee, compare);
         break;
      case 'n':			/* sort employees by name */
      case 'N':
	 compare = name_compare;
	 sort (*idx, employee, compare);
	 break;
      case 'q':                 /* quit */
      case 'Q':
         *done = 1;
         break;
      default:
	 go_on ("Illegal selection.  Press ENTER to continue >");
   }     /* switch */
}     /* process_selection */
