/* remove_emp.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "emps.h"

void remove_emp (empls **head, empls **tail)
{
   /* create two temp pointers:
         1 - node to remove, and
         2 - previous node, to reconnect to removed node's neighbor 
   */ 
   empls *temp_emp  = *head;
   empls *prev      = *head;

   char tmp[45];	     /* temp var to hold string values */
   printf ("Enter employee's name to remove > ");
   gets (tmp);

   /* check if you are removing the first (head) node */
   if ((temp_emp != NULL) && (strcmp(temp_emp->name, tmp) == 0))
   {
      /* reassign the head to the next node in the list */
      *head = (*head)->next;

      /* release the removed node's space back to the system */
      free(temp_emp);
      printf ("Removed %s.  ", tmp);
      go_on("Press ENTER to continue >");
      return;
   }

   /* traverse the list, looking for the value to be removed */
   while ((temp_emp != NULL) && (strcmp (temp_emp->name, tmp) != 0))
   {
      /* trail behind the temp_emp pointer, for later reconnection */
      prev      = temp_emp;
      temp_emp  = temp_emp->next;
   }

   /* now you've either found the node to remove, or you've exhausted
      the list */
   if (NULL == temp_emp)
   {
      /* didn't find the employee in the list */
      printf ("Employee %s not found.  ", tmp);
      go_on("Press ENTER to continue >");
   }     /* NULL = temp_emp */
   else
   {   
      /* found the node, reassign previous pointer to next */
      prev->next = temp_emp->next;
      free (temp_emp);  
      printf ("Removed %s.  ", tmp);
      go_on("Press ENTER to continue >");
   }     /* NULL != temp_emp */

   if (NULL == prev->next)
      /* you deleted the last node in the list, so reassign the tail */
      *tail = prev;
}     /* remove_emp */
