/* insert_employee.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "emps.h"

void insert_employee (empls **head, empls temp_emp)
{
   /* declare two ptrs to precede and follow the current ptr 
      while traversing the list */
   empls *before_newn = *head,
	 *after_newn  = *head;

   /* initialize the new node pointer */
   empls *newn = NULL;

   /* allocate the new node */
   if (NULL == (newn = (empls *) malloc (sizeof (empls))))
   {
      perror ("insert_employee");
      exit (EXIT_FAILURE);
   }

   /* assign the employee contents to the new node */
   *newn = temp_emp;

   /* always initialize your pointers */
   newn->next = NULL;

   /* Will this be the first node in the list? */
   if (*head == NULL)
   {
      /* initialize the pointers */
      *head = newn;
   }    /* *head == NULL */
   else if (strcmp (newn->name, (*head)->name) <= 0 )
   {
      /* new name comes before the head */
      newn->next = *head;
      /* replace the head pointer */
      *head = newn;
   }     /* replace head pointer */
   else 
   {
      /* INSERT the new node in order by its name. */
      while ((after_newn != NULL) && (strcmp(newn->name, after_newn->name) >0))
      {
	 /* assign ptr to the previous node */
	 before_newn = after_newn;

	 /* assign ptr to the following node */
	 after_newn  = after_newn->next;
      }     /* newn->name >= after_newn->name */

      /* Found where to insert the new employee node.  Must
	 attach the previous pointer to the new employee node,
	 and attach the new employee node to the following node. */
      newn->next        = after_newn;
      before_newn->next = newn;
   }     /* *head != NULL */
}     /* insert_employee */
