/* process_selection.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "emps.h"

void process_selection (
   const char selection,    /* selected menu option */
   empls **head,             /* start of list */
   int *done)               /* does user want to quit? */
{
   empls temp_emp;
   
   switch (selection)
   {
      case 'e':                 
      case 'E':
	 /* enter a new emp's info */
	 temp_emp = get_employee (); 

	 /* insert the employee into the list */
         insert_employee (head, temp_emp);
         break;
      case 'a':                 /* display all emps info */
      case 'A':
         display_all (*head);   /* head value won't change */
	 break;
      case 'd':                 /* display an emps info */
      case 'D':
         display_or_update_employee (head, 'd');
         break;
      case 'u':
      case 'U':
         display_or_update_employee (head, 'u');
	 break;
      case 'r':			/* remove an employee */
      case 'R':
         if (*head != NULL)
	    remove_emp (head, NULL);
         else
            go_on("There are no employees in the list." 
	          "  Press ENTER to continue >");
	 break;
      case 'I':
      case 'i':
         if (*head != NULL)
	    delete_all (head);
         else
            go_on("There are no employees in the list." 
	          "  Press ENTER to continue >");
	 break;
      case 'q':                 /* quit */
      case 'Q':
         *done = 1;
         break;
      default:
	 go_on ("Illegal selection.  Press ENTER to continue >");
   }     /* switch */
}     /* process_selection */
