#include <stdio.h>
#include <stdlib.h>
typedef struct alpha_node  
{
   char val;
   struct alpha_node *next;
} alpha;

void insert_node (alpha **head, alpha **tail, alpha temp);
void print_nodes (const alpha *head);

void main (void) 
{
   alpha *head = NULL, *tail = NULL, tmp;
   int c;
   for (c='A'; c<'F'; c++) 
   { 
      tmp.val = c;
      insert_node (&head, &tail, tmp); 
   }
   print_nodes (head);
}

void insert_node (alpha **head, alpha **tail, alpha temp) 
{
   /* initialize the new node pointer */
   alpha *newn = NULL;

   /* allocate the new node */
   if (NULL == (newn = (alpha *)malloc (sizeof (alpha)))) 
   {
      perror ("insert_node");
      exit (EXIT_FAILURE); 
   }
   /* assign the contents to the newly allocated space */
   *newn = temp;
   /* always initialize your pointers */
   newn->next = NULL;

   /* Will this be the first node in the list? */
   if (*head == NULL)
      /* initialize the pointers */
      *head = *tail = newn; 
   else 
   {
      /* append the new node onto the end of the list */
      (*tail)->next = newn; 
      *tail = (*tail)->next;
   }
}

void print_nodes (const alpha *head)
{
   /* starting with the first node in the list */
   const alpha *tmp_node = head;
   /* traverse the list, printing values until you hit the NULL sentinel */
   while (tmp_node != NULL) 
   {
      printf ("%c -> ",tmp_node->val);
      /* advance the pointer to the next node in the list */
      tmp_node = tmp_node->next; 
   }
   /* at NULL sentinel */
   printf ("NULL\n");
}
