/* This program demonstrates the use of errno to recover from a failed attempt
   to open a file.  If the reason for failure is a non-existent file, we'll
   try again.  All other reasons will cause the program to quit. */

#include <errno.h>
#include <fcntl.h>

main(int argc, char *argv[])
{
   int fd;
   char fname[50];
   char answer[10];

   while (1) {

      printf("Enter a file name to open: ");
      gets(fname);     /* Easy, but not the best way to get keyboard input */

      fd = open(fname, O_RDONLY);
      if (fd == -1) {
	 switch (errno) {
	 case ENOENT:               /* File doesn't exist.  We'll try ... */
	    printf("That file does not exist; try again? (y/n): ");
	    gets(answer);
	    if (answer[0] != 'y')
	       exit(-1);            /* NOTE program exit here (Tsk, tsk) */
	    break;
	 default:                   /* All other error types, bail out. */
	    perror("Error attempting to open file");
	    exit(-2);               /* NOTE: Oh my, another exit. */
	    break;
	 }
      }
      else {
         printf("Successful open.  Test over, I'll close it now.  Peace.\n");
         close(fd);
	 break;                    /* NOTE while loop break here */
      }
   }
}
