/* sorts.h */

/* sort the employee list by either name or age, determined by 
   the sent in compare() function */
void sort (
   int idx,                               /* current count of employees */
   struct employees *employee,             /* employee list */
   int (*compare)(const struct employees *, 
		  const struct employees *)); /* comparison function */

/* interchange 2 employees (left and right) within the list */
void swap (
   struct employees *left,       
   struct employees *right);

/* returns 0 if left employee's age is <= right employee's age */
int age_compare (
   const struct employees *left,       /* an employee */
   const struct employees *right);     /* an employee */

/* returns 0 if left employee's name is <= right employee's name */
int name_compare (
   const struct employees *left,       /* an employee */
   const struct employees *right);     /* an employee */
