/* sort.c */
#include <emps.h>
#include <sorts.h>
#include <string.h>

int age_compare (const struct employees *left, 
		 const struct employees *right)
{
   if ((left->age - right->age) > 0)
      return 1;
   else
      return 0;
}     /* age_compare */

int name_compare (const struct employees *left, 
		  const struct employees *right)
{
   if (strcmp (left->name, right->name) > 0)
      return 1;
   else
      return 0;
}     /* name_compare */

/* bubble sort */
void sort (int idx,                              /* num of employees */
           struct employees *employee[],         /* employee list    */
	   int (*compare)(const struct employees *,
			  const struct employees *)) /* comparison function */
{
   int bottom = idx -1;      /* init highest index */
   int i,
       sorted = 0;

   while (!sorted)           /* continue sorting until list is in order */
   {
      sorted = 1;
      for (i=0; i < bottom; i++)
      {
	 /* Use the passed in comparison function to
	    determine whether swap() is to be called.  
	    The compare function is enacted on the elements
	    of the employee list. */

	 /* Compares by either age or name, depending on sent in function.  
	    If the left employee's data is > than right employee's, then
	    a switch is made within the array. */
	 if (compare (employee[i], employee[i+1]))
	 {
	    swap (&employee[i], &employee[i+1]);
	    sorted = 0;
	 }     /* if compare */
      }   /* for i */
   }     /* while !sorted */

   /* Have ordered an element in the array.  You now have one 
      less item to consider in array. */
   bottom--;   
}     /* sort */
