/* 8-132.c */
#include <stdio.h>
#define MAX 25

void main(int argc, char *argv[])
{
   char str [MAX];
   int arg_idx = argc-1;    /* argc has minimum value 1 for prog name */

   switch (arg_idx)
   {
      case 0:
         /* the only argument is the program name (argc = 1)*/
         fputs ("Enter a string ", stdout);

         /* keeps the carriage return, if it fit */
         fgets (str, MAX, stdin);

         /* discard the carriage return */
         if (str[strlen(str)-1] == '\n')
	    str[strlen(str)-1] = '\0';

         fprintf (stdout, "You entered %s.\n", str);
	 break;

      case 1:
	 /* program name + input filename (argc = 2)*/
	 {
	    FILE *ifp;

	    /* open the file specified by the second arg */
            ifp = fopen (argv[arg_idx], "r");
	    fread (str, sizeof str, 1, ifp);
            
            fprintf (stdout, "The file \"%s\" contains: %s.\n",
		     argv[arg_idx], str);
	    fclose (ifp);
	 }
         break;

      case 2:
	 /* program name + input filename + output filename (argc = 3) */
	 {
	    FILE *ifp, *ofp;

	    /* open the file specified by the second arg */
            ifp = fopen (argv[arg_idx-1], "r");
            fgets (str, MAX, ifp);
	    fclose (ifp);

	    /* open the file specified by the third arg */
            ofp = fopen (argv[arg_idx], "w");
            fputs (str, ofp);
	    fclose (ofp);
	 }
	 break;
   }     /* switch */
}     /* main */
