/* emps.h */

typedef struct employees {     
   char name [45];
   long id;
   int  dept;
   int  age;
   struct employees *next;    /* pointer to next node in list */
}empls;                       /* use "empls" label to abbrev type */

/* Read any employees from the file. Note: this may
   change the head and tail pointers, so must send
   address of head and tail. */
void read_employees_from_file (
   empls **head,             /* start of list */
   empls **tail);            /* tail of list */

/* Write any employees to the file. */
void write_employees_to_file (
   const empls *const head);             /* start of list */

/* display menu and get user menu selection */
char get_selection (void); 

/* Perform the user's menu selection.  Note: this
   function may alter the head and tail values. */
void process_selection (
   const char selection,    /* selected menu option */
   empls **head,             /* start of list */
   empls **tail,             /* tail of list */
   int *done);              /* does user want to quit? */

/* Input the employee data.  Returns an employee structure. */
empls get_employee (void);

/* Insert new employee into the list.  Note: this
   function may alter the head and tail values. */
void insert_employee (
   empls **head,             /* start of list */
   empls **tail,             /* tail of list */
   empls temp_emp);          /* employee to add to list */

/* Display the employees entered.  Note: this
   function will not alter the head value.*/
void display_all (
   const empls *head);        /* start of list */

/* Display a selected employee or enter if not found.  Note: 
   this function may alter the head and tail values. */
void display_an_employee (
   empls **head,             /* start of list */
   empls **tail);            /* tail of list */

/* Remove a selected employee from the list.  Note:
   this function may later the head and tail values. */
void remove_emp (
   empls **head,             /* start of list */
   empls **tail);            /* tail of list */

/* display user-defined prompt to continue */
void go_on (const char *);
