#include <stdio.h>
#include <stdlib.h>

typedef struct emps {
   char name [20];
   int age;
} employee;

void swap (employee v[], int (*compare)(employee v[]));

void main (void)
{
   int i;
   int name_compare (employee v[]);  /* determines greater name */
   int age_compare (employee v[]);   /* determines greater age */
   int (*compare)(employee v[]);
   employee emp[2];

   strcpy (emp[0].name, "phido"); emp[0].age = 7;
   strcpy (emp[1].name, "fred"); emp[1].age = 12;

   /* do swap based on names first */
   compare = name_compare;
   puts ("BEFORE NAME SWAP");
   printf ("%s %d\n", emp[0].name, emp[0].age);
   printf ("%s %d\n", emp[1].name, emp[1].age);
   swap (emp, compare);
   puts ("AFTER NAME SWAP");
   printf ("%s %d\n", emp[0].name, emp[0].age);
   printf ("%s %d\n", emp[1].name, emp[1].age);
   
   /* do swap based on age */
   compare = age_compare;
   puts ("BEFORE AGE SWAP");
   printf ("%s %d\n", emp[0].name, emp[0].age);
   printf ("%s %d\n", emp[1].name, emp[1].age);
   swap (emp, compare);
   puts ("AFTER AGE SWAP");
   printf ("%s %d\n", emp[0].name, emp[0].age);
   printf ("%s %d\n", emp[1].name, emp[1].age);
}
int name_compare (employee v[])
{
   return (strcmp (v[0].name, v[1].name));
}     /* name_compare */
int age_compare (employee v[])
{
   return (v[0].age - v[1].age);
}     /* age_compare */
void swap (employee v[], int (*compare)(employee v[]))
{
   employee temp;
   /* compare function called depends on which was sent in */
   if (compare (v) > 0)
   {
      temp = v[0];
      v[0] = v[1];
      v[1] = temp;
   }
}     /* swap */
