/* 3-29.c */

#include <stdio.h>
#include <string.h>     /* for strcmp() */
#include <stdlib.h>     /* for system() */
#define MAX 5           /* maximum number of employees */

void main (void)
{
   char selection;      /* user menu selection */
   int done = 0; 	/* flag indicator of when to leave loop */
   int idx  = 0, 	/* count of records entered so far */
       j    = 0;     	/* used as temp index */ 
   char tmp[45];	/* temp var to hold string values */
   char ch; 		/* temp var to hold user selection */

   struct employees {
      char name [45];
      long id;
      int  dept;
      int  age;
   } employee[MAX];	/* define array of employee structures */

   /* display the menu and get user's selection */
   while (!done)
   {
      /* clear the screen; any shell command may go here */
      system ("clear");	

      printf ("\n\n   EMPLOYEE DATABASE MENU\n\n");
      printf ("e - Enter a new employee's information\n");
      printf ("a - Display all employees information\n");
      printf ("d - Display an employee's information\n");
      printf ("q - QUIT\n\n");
      printf ("Enter your selection > ");

      selection = getchar();
      printf ("\n");

      /* flush the input buffer */
      fflush (stdin);

      /* carry out user's selection */
      switch (selection)
      {
         case 'e':                 /* enter a new emp's info */
         case 'E':
            /* if there is room in the array */
            if (idx < MAX)
            {
               printf ("   e - Enter a new employee's information\n\n");
               printf ("   Enter the employee's name :");
               gets (employee[idx].name);
               printf ("   Enter the employee's id : ");
               employee[idx].id = atol (gets(tmp));
               printf ("   Enter the employee's department number :");
               scanf ("%d", &employee[idx].dept);
               fflush (stdin);
               printf ("   Enter the employee's age :");
               employee[idx].age = atol (gets(tmp));
               idx++;
	       printf("Press ENTER to continue >");
            }     /* if (idx < MAX ) */
	    else
	    {
	       printf ("Sorry, you have exceeded the array limits."); 
               printf ( "  Press ENTER to continue > ");
	    }     /* if (idx > MAX) */

	    /* "pause" the program until user takes action */
	    ch = getchar();
	    /* flush any remaining characters */
	    fflush(stdin);
            break;
         case 'a':                 /* display all emps info */
         case 'A':
            /* if there are employees in the list */
            if (idx > 0)
	    {
               printf ("   a - Display all employees information\n\n");
               printf ("   --------------------------------------\n");

               for (j=0; j < idx; j++)
               {
                  printf ("   %s %d %d %d\n", 
                     employee[j].name,
                     employee[j].id,
                     employee[j].dept,
                     employee[j].age);
               }     /* end for */

               printf ("   --------------------------------------\n");
	       printf("Press ENTER to continue >");

	    }     /* if (idx > 0) */
	    else 
	    {
	       printf ("There are no employees in the list."
		       "  Press ENTER to continue >");
	    }     /* idx < 0 */

	    /* "pause" the program until user takes action */
	    ch = getchar();
	    /* flush any remaining characters */
	    fflush(stdin);
            break;
         case 'd':                 /* display an emps info */
	 case 'D':
	    printf ("Enter employee's name > ");
	    gets (tmp);

            /* starting from the first employee, search for employee tmp */
	    for (j = 0; j < idx; j++)
	    {
	       if (strcmp (employee[j].name, tmp) == 0)
	       {
		  /* found the employee, print the information */
                  printf ("   --------------------------------------\n");
                  printf ("   %s %d %d %d\n", 
                     employee[j].name,
                     employee[j].id,
                     employee[j].dept,
                     employee[j].age);
                  printf ("   --------------------------------------\n");
	          printf("Press ENTER to continue >");
		  break;
	       }   /* end if */
	    }   /* end for */
	    if (j == idx)
	    {
	       /* didn't find the employee in the list, enter them? */
	       printf ("Employee %s not found.  "
		       "Do you want to add %s (y/n) ?", tmp,tmp);

               if ((ch = toupper (getchar())) == 'Y')
	       {
		  fflush (stdin);

                  /* if there is still room, enter the employee information */
                  if (idx < MAX)
                  {
                     printf ("   Enter the employee's name :");
                     gets (employee[idx].name);
                     printf ("   Enter the employee's id : ");
                     employee[idx].id = atol (gets(tmp));
                     printf ("   Enter the employee's department number :");
                     scanf ("%d", &employee[idx].dept);
                     fflush (stdin);
                     printf ("   Enter the employee's age :");
                     employee[idx].age = atol (gets(tmp));
                     idx++;
                     printf ( "  Press ENTER to continue > ");
                  }     /* if (idx < MAX) */
   	          else
   	          {
            	     printf ("Sorry, you have exceeded the array limits."); 
                     printf ( "  Press ENTER to continue > ");

	          }     /* (idx >= MAX) */
	       }     /* if user wants to add new employee */
	       else
	       {
                  printf ( "Press ENTER to continue >");

	       }     /* end if - don't add new employee */
	    }     /* j == idx */

	    /* "pause" the program until user takes action */
	    ch = getchar();
	    /* flush any remaining characters */
	    fflush(stdin);
	    break;
         case 'q':                 /* quit */
         case 'Q':
            done = 1;
            break;
         default:
            printf (
	       "%c : Illegal selection.  Press ENTER to continue >",selection);

	    ch = getchar();
	    fflush (stdin);
      }     /* switch */
   }     /* while */
}     /* main */
