/* read_emps.c */
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <emps.h>

void read_employees_from_file (struct employees *employee, int *idx)
{
   int ifd;
   int num_read = 0;        /* number of bytes read */
   struct employees temp;

   /* open the file for reading */
   if ((ifd = open ("employees", O_RDONLY)) != -1)
   {
      /* File existed.  Read existing employees into list, one at a time. */
      while ((num_read = read (ifd, &temp, sizeof (struct employees)) == 
              sizeof (struct employees)))
      {
	 /* check if there is room in the array to add another employee */
	 if (*idx < MAX)
	 {
	    employee[*idx] = temp;

	    /* increment the number of employees in the list */
	    (*idx)++;
	 }     /* *idx < MAX */
	 else
	    /* list of employees is full */
	    print_sorry ();

      }     /* while num_read */ 

      /* close the existing file */
      fclose (ifd);
   }     /* if fopen */
}     /* read_employees_from_file */
