/* read_emps.c */
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <emps.h>

void read_employees_from_file (struct employees *employee[], int *idx)
{
   FILE *ifp;
   struct employees temp;

   /* open the file for reading */
   if ((ifp = fopen ("employees", "r")) != NULL)
   {
      /* File existed.  Read existing employees into list, one at a time. */
      while (1 == fread (&temp, sizeof(struct employees), 1, ifp))
      {
	 /* check if there is room in the array to add another employee */
	 if (*idx < MAX)
	 {
	    /* allocate the employee structure */
	    if ((employee[*idx] = 
	       (struct employees *)malloc(sizeof (struct employees))) == NULL)
	    {
	       perror ("read_employees_from_file");
	       exit (errno);
	    }     /* if malloc */
	    
	    /* assign the contents to the structure */
	    *employee[*idx] = temp;

	    /* increment the number of employees in the list */
	    (*idx)++;
	 }     /* *idx < MAX */
	 else
	    /* list of employees is full */
	    print_sorry ();

      }     /* while fread */

      /* close the existing file */
      fclose (ifp);
   }     /* if fopen */
}     /* read_employees_from_file */
