/* process_selection.c */

#include <emps.h>
#include <stdlib.h>
/*#include <sorts.h> */    /* for the sort routines */

void process_selection (
   const char selection,    /* selected menu option */
   empls **head,             /* start of list */
   empls **tail,             /* tail of list */
   int *done)               /* does user want to quit? */
{
   empls temp_emp;
   
   switch (selection)
   {
      case 'e':                 
      case 'E':
	 /* enter a new emp's info */
	 temp_emp = get_employee (); 

	 /* insert the employee into the list */
         insert_employee (head, tail, temp_emp);
         break;
      case 'a':                 /* display all emps info */
      case 'A':
         display_all (*head);   /* head value won't change */
	 break;
      case 'd':                 /* display an emps info */
      case 'D':
         display_an_employee (head, tail);
         break;
      case 'r':			/* remove an employee */
      case 'R':
         if (*head != NULL)
	    remove_emp (head, tail);
         else
            go_on("There are no employees in the list." 
	          "  Press ENTER to continue >");
	 break;
      case 'q':                 /* quit */
      case 'Q':
         *done = 1;
         break;
      default:
	 go_on ("Illegal selection.  Press ENTER to continue >");
   }     /* switch */
}     /* process_selection */
